import 'dart:io';
import 'dart:convert';
import 'dart:math';
import 'package:dart_database/dart_database.dart';

class JsonEncoderEx extends Converter<Map<Symbol, dynamic>, String> {
  @override
  String convert(Map<Symbol, dynamic> input) {
    JsonEncoder encoder = new JsonEncoder();
    String result = input.keys.map((Symbol key) {
      String keyStr = key.toString();
      String jsonKey = keyStr.substring(8, keyStr.length - 2);
      String value = encoder.convert(input[key]);

      return '"$jsonKey": $value';
    }).toList().join(',');

    return '\{$result\}';
  }
}

class Order extends Entity {
  int get orderId => this['orderId'];
  int get price => this['price'];
  String get title => this['title'];

  Order({
    int price,
    String title,
  }) {
    this['orderId'] = new Random().nextInt(9999998) + 1;
    this['price'] = price;
    this['title'] = title;
  }

  void set price(int value) {
    this['price'] = value;
  }
  void set title(String value) {
    this['title'] = value;
  }
}

void main() {
  bootstrap({
    'dbPath': Platform.script.resolve('./db').toFilePath(),
  });
  Collection<Order> orders = new Collection<Order>(
    builder: () => new Order(),
  );

  // for(int i = 0; i < 1e6; i ++) {
  //   orders.add(new Order(price: new Random(i).nextInt(100) + 5, title: 'Order #$i'));
  // }
  // orders.forEach((Order order) {
  //   print(order);
  // });
  Order o = new Order(price: 100, title: 'test');
  DateTime time = new DateTime.now();
  Order order = orders.elementAt(100);
  print(BlockSize.determineBlockSize(o.serialize().length));

  print(order);
  print((new DateTime.now().microsecondsSinceEpoch - time.microsecondsSinceEpoch) / 1000000);
  // List<Block> blocks = orders.getBlocks();
  // int abandoned = 0;
  // int deleted = 0;
  // int size = 0;

  // blocks.forEach((Block block) {
  //   switch (block.blockType) {
  //     case BlockType.ABANDONED:
  //       abandoned += 1;
  //       break;
  //     case BlockType.DELETED:
  //       deleted += 1;
  //       break;
  //   }
  //   size += block.size / 1024 / 1024;
  // });
  // print('Orders collection consists of ${blocks.length} blocks');
  // print('$deleted blocks are deleted');
  // print('$abandoned blocks abandoned');
  // print('Size of collection: ${size} Mb');
}
